Subject: Re: bug#51658: [PATCH] Haiku port (again)

From: Eli Zaretskii <[email-masked]>
Date: Wed, 10 Nov 2021 16:19:49 +0200

> From: Po Lu <[email-masked]>
> Cc: [email-masked]
> Date: Wed, 10 Nov 2021 20:56:10 +0800
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> > Too bad.  IMNSHO, that's a ticking time bomb, and it will certainly
> > bite us at some point, since mixing C and C++ is tricky and requires a
> > lot of diligence.  It also means that you will probably be unable to
> > use any compiler but GCC (or whatever is currently supported by
> > Haiku), since different C++ compilers are generally
> > binary-incompatible.
> 
> AFAIU, the Haiku developers only support GCC for compiling C++ code, as
> they have a requirement to keep support for old BeOS software, which
> depends on the GCC ABI.

And for a good reason.  Then I think you should remove the part of
configure.ac that looks for other C++ compilers, as that is entirely
unnecessary, and probably will always be.

> > Since you later say Cairo is unreliable, why not drop Cairo?
> 
> What I meant by "unreliable" is that the Haiku developers tend to tweak
> their Cairo package in various manners, which breaks the Emacs build.
> 
> People building Cairo themselves won't experience this problem, but
> building the BeOS cairo backend is... tricky, to say the least.  I
> managed to get it to work, but there is a lot of pain involved in it
> that I wouldn't want to repeat.
> 
> The Haiku developers have a package repository and build automation
> system that would make this easy, should they ship the Haiku port of
> Emacs in the future.  (At present, they only ship Emacs built to run in
> a TTY.)
> 
> So it is useful to have Cairo around, for people whom it is useful, but
> if not, it would be good to have something to fall back to.
> 
> > And that still leaves us with 3 backends, IIUC.  Why not just one?
> 
> Well, one of those backends is simply a HarfBuzz variant of the other,
> which is how xftfont and ftcrfont do it, and IIUC, that's how it works
> under MS-Windows too.

The other platforms have past history, which Haiku doesn't.  And we
plan on removing more old backends in the future; for example
Uniscribe for Windows will die soon enough because MS deprecated it,
and it is not being developed anymore, so falls behind in supporting
new scripts and features.

> So, if we keep only the haikufont backend (for Haiku users who don't
> want to install FreeType or Cairo), and one of `ftbe' or cairo font
> support, there will really just be two font backends.

OK, let's go with two.  I understand that both will use HarfBuzz?  I'd
prefer not to have backends that use other shaping engines, unless
Haiku has some shaping engine that is better than HarfBuzz.

> Aside from not depending on Cairo or FreeType, which are not always
> available on Haiku, it also comes with the advantage of being fast even
> on remote sessions (not unlike X11 remote access), as characters drawn
> are sent down the wire as plain text, instead of as bitmap data, which
> is very slow when operating over a remote connection.
> 
> So I think it will be useful as a fallback in many cases.

I hope you will reconsider.  Having a niche platform with 3 font
backends is really too much.  Especially since Emacs 29 learned to
display Emoji now, and we are talking about adding decent support for
ligatures, both of which require a shaping engine.

> > So my suggestion is to choose wisely which features you really need to
> > keep.
> 
> Yes, thanks.

OK, please post an updated patch, and we'll take it from there.

Thanks.